JUCE: Toolbar Class Reference

JUCE

- Main Page
- Related Pages
- Topics
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Loading...
Searching...
No Matches
Classes | Public Types | Public Member Functions | Static Public Member Functions | Static Public Attributes | List of all members
Toolbar Class Reference
juce_gui_basics » widgets

A toolbar component. More...

`#include <juce_Toolbar.h>`

Inheritance diagram for Toolbar:

## Classes
struct | LookAndFeelMethods
| This abstract base class is implemented by LookAndFeel classes. More...

## Public Types
enum | ToolbarItemStyle { iconsOnly , iconsWithText , textOnly }
| Options for the way items should be displayed. More...
enum | CustomisationFlags { allowIconsOnlyChoice = 1 , allowIconsWithTextChoice = 2 , allowTextOnlyChoice = 4 , showResetToDefaultsButton = 8 , allCustomisationOptionsEnabled = (allowIconsOnlyChoice | allowIconsWithTextChoice | allowTextOnlyChoice | showResetToDefaultsButton) }
| Flags used by the showCustomisationDialog() method. More...
enum | ColourIds { backgroundColourId = 0x1003200 , separatorColourId = 0x1003210 , buttonMouseOverBackgroundColourId = 0x1003220 , buttonMouseDownBackgroundColourId = 0x1003230 , labelTextColourId = 0x1003240 , editingModeOutlineColourId = 0x1003250 , customisationDialogBackgroundColourId = 0x1003260 }
| A set of colour IDs to use to change the colour of various aspects of the toolbar. More...
Public Types inherited from Component
enum class | FocusContainerType { none , focusContainer , keyboardFocusContainer }
| A focus container type that can be passed to setFocusContainerType(). More...
enum | FocusChangeType { focusChangedByMouseClick , focusChangedByTabKey , focusChangedDirectly }
| Enumeration used by the focusGained() and focusLost() methods. More...
enum class | FocusChangeDirection { unknown , forward , backward }
| Enumeration used by the focusGainedWithDirection() method. More...

## Public Member Functions
| Toolbar ()
| Creates an empty toolbar component.
| ~Toolbar () override
| Destructor.
void | setVertical (bool shouldBeVertical)
| Changes the bar's orientation.
bool | isVertical () const noexcept
| Returns true if the bar is set to be vertical, or false if it's horizontal.
int | getThickness () const noexcept
| Returns the depth of the bar.
int | getLength () const noexcept
| Returns the length of the bar.
void | clear ()
| Deletes all items from the bar.
void | addItem (ToolbarItemFactory &factory, int itemId, int insertIndex=-1)
| Adds an item to the toolbar.
void | removeToolbarItem (int itemIndex)
| Deletes one of the items from the bar.
ToolbarItemComponent * | removeAndReturnItem (int itemIndex)
| Removes an item from the bar and returns it.
int | getNumItems () const noexcept
| Returns the number of items currently on the toolbar.
int | getItemId (int itemIndex) const noexcept
| Returns the ID of the item with the given index.
ToolbarItemComponent * | getItemComponent (int itemIndex) const noexcept
| Returns the component being used for the item with the given index.
void | addDefaultItems (ToolbarItemFactory &factoryToUse)
| Clears this toolbar and adds to it the default set of items that the specified factory creates.
ToolbarItemStyle | getStyle () const noexcept
| Returns the toolbar's current style.
void | setStyle (const ToolbarItemStyle &newStyle)
| Changes the toolbar's current style.
void | showCustomisationDialog (ToolbarItemFactory &factory, int optionFlags=allCustomisationOptionsEnabled)
| Pops up a modal dialog box that allows this toolbar to be customised by the user.
void | setEditingActive (bool editingEnabled)
| Turns on or off the toolbar's editing mode, in which its items can be rearranged by the user.
String | toString () const
| Returns a string that represents the toolbar's current set of items.
bool | restoreFromString (ToolbarItemFactory &factoryToUse, const String &savedVersion)
| Restores a set of items that was previously stored in a string by the toString() method.
void | paint (Graphics &) override
| Components can override this method to draw their content.
void | resized () override
| Called when this component's size has been changed.
void | mouseDown (const MouseEvent &) override
| Called when a mouse button is pressed.
bool | isInterestedInDragSource (const SourceDetails &) override
| Callback to check whether this target is interested in the type of object being dragged.
void | itemDragMove (const SourceDetails &) override
| Callback to indicate that the user is dragging something over this component.
void | itemDragExit (const SourceDetails &) override
| Callback to indicate that something has been dragged off the edge of this component.
void | itemDropped (const SourceDetails &) override
| Callback to indicate that the user has dropped something onto this component.
void | lookAndFeelChanged () override
| Called to let the component react to a change in the look-and-feel setting.
void | updateAllItemPositions (bool animate)
std::unique_ptr< AccessibilityHandler > | createAccessibilityHandler () override
| Override this method to return a custom AccessibilityHandler for this component.
Public Member Functions inherited from Component
| Component () noexcept
| Creates a component.
| ~Component () override
| Destructor.
| Component (const String &componentName) noexcept
| Creates a component, setting its name at the same time.
String | getName () const noexcept
| Returns the name of this component.
virtual void | setName (const String &newName)
| Sets the name of this component.
String | getComponentID () const noexcept
| Returns the ID string that was set by setComponentID().
void | setComponentID (const String &newID)
| Sets the component's ID string.
virtual void | setVisible (bool shouldBeVisible)
| Makes the component visible or invisible.
bool | isVisible () const noexcept
| Tests whether the component is visible or not.
virtual void | visibilityChanged ()
| Called when this component's visibility changes.
bool | isShowing () const
| Tests whether this component and all its parents are visible.
virtual void | addToDesktop (int windowStyleFlags, void *nativeWindowToAttachTo=nullptr)
| Makes this component appear as a window on the desktop.
void | removeFromDesktop ()
| If the component is currently showing on the desktop, this will hide it.
bool | isOnDesktop () const noexcept
| Returns true if this component is currently showing on the desktop.
ComponentPeer * | getPeer () const
| Returns the heavyweight window that contains this component.
virtual void | userTriedToCloseWindow ()
| For components on the desktop, this is called if the system wants to close the window.
virtual void | minimisationStateChanged (bool isNowMinimised)
| Called for a desktop component which has just been minimised or un-minimised.
virtual float | getDesktopScaleFactor () const
| Returns the default scale factor to use for this component when it is placed on the desktop.
void | toFront (bool shouldAlsoGainKeyboardFocus)
| Brings the component to the front of its siblings.
void | toBack ()
| Changes this component's z-order to be at the back of all its siblings.
void | toBehind (Component *other)
| Changes this component's z-order so that it's just behind another component.
void | setAlwaysOnTop (bool shouldStayOnTop)
| Sets whether the component should always be kept at the front of its siblings.
bool | isAlwaysOnTop () const noexcept
| Returns true if this component is set to always stay in front of its siblings.
int | getX () const noexcept
| Returns the x coordinate of the component's left edge.
int | getY () const noexcept
| Returns the y coordinate of the top of this component.
int | getWidth () const noexcept
| Returns the component's width in pixels.
int | getHeight () const noexcept
| Returns the component's height in pixels.
int | getRight () const noexcept
| Returns the x coordinate of the component's right-hand edge.
Point< int > | getPosition () const noexcept
| Returns the component's top-left position as a Point.
int | getBottom () const noexcept
| Returns the y coordinate of the bottom edge of this component.
Rectangle< int > | getBounds () const noexcept
| Returns this component's bounding box.
Rectangle< int > | getLocalBounds () const noexcept
| Returns the component's bounds, relative to its own origin.
Rectangle< int > | getBoundsInParent () const noexcept
| Returns the area of this component's parent which this component covers.
int | getScreenX () const
| Returns this component's x coordinate relative the screen's top-left origin.
int | getScreenY () const
| Returns this component's y coordinate relative the screen's top-left origin.
Point< int > | getScreenPosition () const
| Returns the position of this component's top-left corner relative to the screen's top-left.
Rectangle< int > | getScreenBounds () const
| Returns the bounds of this component, relative to the screen's top-left.
Point< int > | getLocalPoint (const Component *sourceComponent, Point< int > pointRelativeToSourceComponent) const
| Converts a point to be relative to this component's coordinate space.
Point< float > | getLocalPoint (const Component *sourceComponent, Point< float > pointRelativeToSourceComponent) const
| Converts a point to be relative to this component's coordinate space.
Rectangle< int > | getLocalArea (const Component *sourceComponent, Rectangle< int > areaRelativeToSourceComponent) const
| Converts a rectangle to be relative to this component's coordinate space.
Rectangle< float > | getLocalArea (const Component *sourceComponent, Rectangle< float > areaRelativeToSourceComponent) const
| Converts a rectangle to be relative to this component's coordinate space.
Point< int > | localPointToGlobal (Point< int > localPoint) const
| Converts a point relative to this component's top-left into a screen coordinate.
Point< float > | localPointToGlobal (Point< float > localPoint) const
| Converts a point relative to this component's top-left into a screen coordinate.
Rectangle< int > | localAreaToGlobal (Rectangle< int > localArea) const
| Converts a rectangle from this component's coordinate space to a screen coordinate.
Rectangle< float > | localAreaToGlobal (Rectangle< float > localArea) const
| Converts a rectangle from this component's coordinate space to a screen coordinate.
void | setTopLeftPosition (int x, int y)
| Moves the component to a new position.
void | setTopLeftPosition (Point< int > newTopLeftPosition)
| Moves the component to a new position.
void | setTopRightPosition (int x, int y)
| Moves the component to a new position.
void | setSize (int newWidth, int newHeight)
| Changes the size of the component.
void | setBounds (int x, int y, int width, int height)
| Changes the component's position and size.
void | setBounds (Rectangle< int > newBounds)
| Changes the component's position and size.
void | setBoundsRelative (float proportionalX, float proportionalY, float proportionalWidth, float proportionalHeight)
| Changes the component's position and size in terms of fractions of its parent's size.
void | setBoundsRelative (Rectangle< float > proportionalArea)
| Changes the component's position and size in terms of fractions of its parent's size.
void | setBoundsInset (BorderSize< int > borders)
| Changes the component's position and size based on the amount of space to leave around it.
void | setBoundsToFit (Rectangle< int > targetArea, Justification justification, bool onlyReduceInSize)
| Positions the component within a given rectangle, keeping its proportions unchanged.
void | setCentrePosition (int x, int y)
| Changes the position of the component's centre.
void | setCentrePosition (Point< int > newCentrePosition)
| Changes the position of the component's centre.
void | setCentreRelative (float x, float y)
| Changes the position of the component's centre.
void | centreWithSize (int width, int height)
| Changes the component's size and centres it within its parent.
void | setTransform (const AffineTransform &transform)
| Sets a transform matrix to be applied to this component.
AffineTransform | getTransform () const
| Returns the transform that is currently being applied to this component.
bool | isTransformed () const noexcept
| Returns true if a non-identity transform is being applied to this component.
int | proportionOfWidth (float proportion) const noexcept
| Returns a proportion of the component's width.
int | proportionOfHeight (float proportion) const noexcept
| Returns a proportion of the component's height.
int | getParentWidth () const noexcept
| Returns the width of the component's parent.
int | getParentHeight () const noexcept
| Returns the height of the component's parent.
Rectangle< int > | getParentMonitorArea () const
| Returns the screen coordinates of the monitor that contains this component.
int | getNumChildComponents () const noexcept
| Returns the number of child components that this component contains.
Component * | getChildComponent (int index) const noexcept
| Returns one of this component's child components, by it index.
int | getIndexOfChildComponent (const Component *child) const noexcept
| Returns the index of this component in the list of child components.
const Array< Component * > & | getChildren () const noexcept
| Provides access to the underlying array of child components.
Component * | findChildWithID (StringRef componentID) const noexcept
| Looks for a child component with the specified ID.
void | addChildComponent (Component *child, int zOrder=-1)
| Adds a child component to this one.
void | addChildComponent (Component &child, int zOrder=-1)
| Adds a child component to this one.
void | addAndMakeVisible (Component *child, int zOrder=-1)
| Adds a child component to this one, and also makes the child visible if it isn't already.
void | addAndMakeVisible (Component &child, int zOrder=-1)
| Adds a child component to this one, and also makes the child visible if it isn't already.
void | addChildAndSetID (Component *child, const String &componentID)
| Adds a child component to this one, makes it visible, and sets its component ID.
void | removeChildComponent (Component *childToRemove)
| Removes one of this component's child-components.
Component * | removeChildComponent (int childIndexToRemove)
| Removes one of this component's child-components by index.
void | removeAllChildren ()
| Removes all this component's children.
void | deleteAllChildren ()
| Removes and deletes all of this component's children.
Component * | getParentComponent () const noexcept
| Returns the component which this component is inside.
template<class TargetClass >
TargetClass * | findParentComponentOfClass () const
| Searches the parent components for a component of a specified class.
Component * | getTopLevelComponent () const noexcept
| Returns the highest-level component which contains this one or its parents.
bool | isParentOf (const Component *possibleChild) const noexcept
| Checks whether a component is anywhere inside this component or its children.
virtual void | parentHierarchyChanged ()
| Called to indicate that the component's parents have changed.
virtual void | childrenChanged ()
| Subclasses can use this callback to be told when children are added or removed, or when their z-order changes.
virtual bool | hitTest (int x, int y)
| Tests whether a given point is inside the component.
void | setInterceptsMouseClicks (bool allowClicksOnThisComponent, bool allowClicksOnChildComponents) noexcept
| Changes the default return value for the hitTest() method.
void | getInterceptsMouseClicks (bool &allowsClicksOnThisComponent, bool &allowsClicksOnChildComponents) const noexcept
| Retrieves the current state of the mouse-click interception flags.
bool | contains (Point< int > localPoint)
| Returns true if a given point lies within this component or one of its children.
bool | contains (Point< float > localPoint)
| Returns true if a given point lies within this component or one of its children.
bool | reallyContains (Point< int > localPoint, bool returnTrueIfWithinAChild)
| Returns true if a given point lies in this component, taking any overlapping siblings into account.
bool | reallyContains (Point< float > localPoint, bool returnTrueIfWithinAChild)
| Returns true if a given point lies in this component, taking any overlapping siblings into account.
Component * | getComponentAt (int x, int y)
| Returns the component at a certain point within this one.
Component * | getComponentAt (Point< int > position)
| Returns the component at a certain point within this one.
Component * | getComponentAt (Point< float > position)
| Returns the component at a certain point within this one.
void | repaint ()
| Marks the whole component as needing to be redrawn.
void | repaint (int x, int y, int width, int height)
| Marks a subsection of this component as needing to be redrawn.
void | repaint (Rectangle< int > area)
| Marks a subsection of this component as needing to be redrawn.
void | setBufferedToImage (bool shouldBeBuffered)
| Makes the component use an internal buffer to optimise its redrawing.
Image | createComponentSnapshot (Rectangle< int > areaToGrab, bool clipImageToComponentBounds=true, float scaleFactor=1.0f)
| Generates a snapshot of part of this component.
void | paintEntireComponent (Graphics &context, bool ignoreAlphaLevel)
| Draws this component and all its subcomponents onto the specified graphics context.
void | setPaintingIsUnclipped (bool shouldPaintWithoutClipping) noexcept
| This allows you to indicate that this component doesn't require its graphics context to be clipped when it is being painted.
bool | isPaintingUnclipped () const noexcept
| Returns true if this component doesn't require its graphics context to be clipped when it is being painted.
void | setComponentEffect (ImageEffectFilter *newEffect)
| Adds an effect filter to alter the component's appearance.
ImageEffectFilter * | getComponentEffect () const noexcept
| Returns the current component effect.
LookAndFeel & | getLookAndFeel () const noexcept
| Finds the appropriate look-and-feel to use for this component.
void | setLookAndFeel (LookAndFeel *newLookAndFeel)
| Sets the look and feel to use for this component.
void | sendLookAndFeelChange ()
| Calls the methods repaint(), lookAndFeelChanged(), and colourChanged() in this component and all its children recursively.
void | setOpaque (bool shouldBeOpaque)
| Indicates whether any parts of the component might be transparent.
bool | isOpaque () const noexcept
| Returns true if no parts of this component are transparent.
void | setBroughtToFrontOnMouseClick (bool shouldBeBroughtToFront) noexcept
| Indicates whether the component should be brought to the front when clicked.
bool | isBroughtToFrontOnMouseClick () const noexcept
| Indicates whether the component should be brought to the front when clicked-on.
void | setExplicitFocusOrder (int newFocusOrderIndex)
| Sets the focus order of this component.
int | getExplicitFocusOrder () const
| Returns the focus order of this component, if one has been specified.
void | setFocusContainerType (FocusContainerType containerType) noexcept
| Sets whether this component is a container for components that can have their focus traversed, and the type of focus traversal that it supports.
bool | isFocusContainer () const noexcept
| Returns true if this component has been marked as a focus container.
bool | isKeyboardFocusContainer () const noexcept
| Returns true if this component has been marked as a keyboard focus container.
Component * | findFocusContainer () const
| Returns the focus container for this component.
Component * | findKeyboardFocusContainer () const
| Returns the keyboard focus container for this component.
void | setWantsKeyboardFocus (bool wantsFocus) noexcept
| Sets a flag to indicate whether this component wants keyboard focus or not.
bool | getWantsKeyboardFocus () const noexcept
| Returns true if the component is interested in getting keyboard focus.
void | setMouseClickGrabsKeyboardFocus (bool shouldGrabFocus)
| Chooses whether a click on this component automatically grabs the focus.
bool | getMouseClickGrabsKeyboardFocus () const noexcept
| Returns the last value set with setMouseClickGrabsKeyboardFocus().
void | grabKeyboardFocus ()
| Tries to give keyboard focus to this component.
void | giveAwayKeyboardFocus ()
| If this component or any of its children currently have the keyboard focus, this will defocus it, send a focus change notification, and try to pass the focus to the next component.
bool | hasKeyboardFocus (bool trueIfChildIsFocused) const
| Returns true if this component currently has the keyboard focus.
void | moveKeyboardFocusToSibling (bool moveToNext)
| Tries to move the keyboard focus to one of this component's siblings.
virtual std::unique_ptr< ComponentTraverser > | createFocusTraverser ()
| Creates a ComponentTraverser object to determine the logic by which focus should be passed from this component.
virtual std::unique_ptr< ComponentTraverser > | createKeyboardFocusTraverser ()
| Creates a ComponentTraverser object to use to determine the logic by which keyboard focus should be passed from this component.
void | setHasFocusOutline (bool hasFocusOutline) noexcept
| Use this to indicate that the component should have an outline drawn around it when it has keyboard focus.
bool | hasFocusOutline () const noexcept
| Returns true if this component should have a focus outline.
bool | isEnabled () const noexcept
| Returns true if the component (and all its parents) are enabled.
void | setEnabled (bool shouldBeEnabled)
| Enables or disables this component.
virtual void | enablementChanged ()
| Callback to indicate that this component has been enabled or disabled.
float | getAlpha () const noexcept
| Returns the component's current transparency level.
void | setAlpha (float newAlpha)
| Changes the transparency of this component.
virtual void | alphaChanged ()
| Called when setAlpha() is used to change the alpha value of this component.
void | setMouseCursor (const MouseCursor &cursorType)
| Changes the mouse cursor shape to use when the mouse is over this component.
virtual MouseCursor | getMouseCursor ()
| Returns the mouse cursor shape to use when the mouse is over this component.
void | updateMouseCursor () const
| Forces the current mouse cursor to be updated.
virtual void | paintOverChildren (Graphics &g)
| Components can override this method to draw over the top of their children.
void | mouseMove (const MouseEvent &event) override
| Called when the mouse moves inside a component.
void | mouseEnter (const MouseEvent &event) override
| Called when the mouse first enters a component.
void | mouseExit (const MouseEvent &event) override
| Called when the mouse moves out of a component.
void | mouseDrag (const MouseEvent &event) override
| Called when the mouse is moved while a button is held down.
void | mouseUp (const MouseEvent &event) override
| Called when a mouse button is released.
void | mouseDoubleClick (const MouseEvent &event) override
| Called when a mouse button has been double-clicked on a component.
void | mouseWheelMove (const MouseEvent &event, const MouseWheelDetails &wheel) override
| Called when the mouse-wheel is moved.
void | mouseMagnify (const MouseEvent &event, float scaleFactor) override
| Called when a pinch-to-zoom mouse-gesture is used.
void | setRepaintsOnMouseActivity (bool shouldRepaint) noexcept
| Causes automatic repaints when the mouse enters or exits this component.
void | addMouseListener (MouseListener *newListener, bool wantsEventsForAllNestedChildComponents)
| Registers a listener to be told when mouse events occur in this component.
void | removeMouseListener (MouseListener *listenerToRemove)
| Deregisters a mouse listener.
void | addKeyListener (KeyListener *newListener)
| Adds a listener that wants to hear about keypresses that this component receives.
void | removeKeyListener (KeyListener *listenerToRemove)
| Removes a previously-registered key listener.
virtual bool | keyPressed (const KeyPress &key)
| Called when a key is pressed.
virtual bool | keyStateChanged (bool isKeyDown)
| Called when a key is pressed or released.
virtual void | modifierKeysChanged (const ModifierKeys &modifiers)
| Called when a modifier key is pressed or released.
virtual void | focusGained (FocusChangeType cause)
| Called to indicate that this component has just acquired the keyboard focus.
virtual void | focusGainedWithDirection (FocusChangeType cause, FocusChangeDirection direction)
| Called to indicate that this component has just acquired the keyboard focus.
virtual void | focusLost (FocusChangeType cause)
| Called to indicate that this component has just lost the keyboard focus.
virtual void | focusOfChildComponentChanged (FocusChangeType cause)
| Called to indicate a change in whether or not this component is the parent of the currently-focused component.
bool | isMouseOver (bool includeChildren=false) const
| Returns true if the mouse is currently over this component.
bool | isMouseButtonDown (bool includeChildren=false) const
| Returns true if the mouse button is currently held down in this component.
bool | isMouseOverOrDragging (bool includeChildren=false) const
| True if the mouse is over this component, or if it's being dragged in this component.
Point< int > | getMouseXYRelative () const
| Returns the mouse's current position, relative to this component.
virtual void | moved ()
| Called when this component's position has been changed.
virtual void | childBoundsChanged (Component *child)
| Called when one of this component's children is moved or resized.
virtual void | parentSizeChanged ()
| Called when this component's immediate parent has been resized.
virtual void | broughtToFront ()
| Called when this component has been moved to the front of its siblings.
void | addComponentListener (ComponentListener *newListener)
| Adds a listener to be told about changes to the component hierarchy or position.
void | removeComponentListener (ComponentListener *listenerToRemove)
| Removes a component listener.
void | postCommandMessage (int commandId)
| Dispatches a numbered message to this component.
virtual void | handleCommandMessage (int commandId)
| Called to handle a command that was sent by postCommandMessage().
int | runModalLoop ()
| Runs a component modally, waiting until the loop terminates.
void | enterModalState (bool takeKeyboardFocus=true, ModalComponentManager::Callback *callback=nullptr, bool deleteWhenDismissed=false)
| Puts the component into a modal state.
void | exitModalState (int returnValue=0)
| Ends a component's modal state.
bool | isCurrentlyModal (bool onlyConsiderForemostModalComponent=true) const noexcept
| Returns true if this component is the modal one.
bool | isCurrentlyBlockedByAnotherModalComponent () const
| Checks whether there's a modal component somewhere that's stopping this one from receiving messages.
virtual bool | canModalEventBeSentToComponent (const Component *targetComponent)
| When a component is modal, this callback allows it to choose which other components can still receive events.
virtual void | inputAttemptWhenModal ()
| Called when the user tries to click on a component that is blocked by another modal component.
NamedValueSet & | getProperties () noexcept
| Returns the set of properties that belong to this component.
const NamedValueSet & | getProperties () const noexcept
| Returns the set of properties that belong to this component.
Colour | findColour (int colourID, bool inheritFromParent=false) const
| Looks for a colour that has been registered with the given colour ID number.
void | setColour (int colourID, Colour newColour)
| Registers a colour to be used for a particular purpose.
void | removeColour (int colourID)
| If a colour has been set with setColour(), this will remove it.
bool | isColourSpecified (int colourID) const
| Returns true if the specified colour ID has been explicitly set for this component using the setColour() method.
void | copyAllExplicitColoursTo (Component &target) const
| This looks for any colours that have been specified for this component, and copies them to the specified target component.
virtual void | colourChanged ()
| This method is called when a colour is changed by the setColour() method, or when the look-and-feel is changed by the setLookAndFeel() or sendLookAndFeelChanged() methods.
void * | getWindowHandle () const
| Returns the underlying native window handle for this component.
Positioner * | getPositioner () const noexcept
| Returns the Positioner object that has been set for this component.
void | setPositioner (Positioner *newPositioner)
| Sets a new Positioner object for this component.
void | setCachedComponentImage (CachedComponentImage *newCachedImage)
| Gives the component a CachedComponentImage that should be used to buffer its painting.
CachedComponentImage * | getCachedComponentImage () const noexcept
| Returns the object that was set by setCachedComponentImage().
void | setViewportIgnoreDragFlag (bool ignoreDrag) noexcept
| Sets a flag to indicate whether mouse drag events on this Component should be ignored when it is inside a Viewport with drag-to-scroll functionality enabled.
bool | getViewportIgnoreDragFlag () const noexcept
| Retrieves the current state of the Viewport drag-to-scroll functionality flag.
String | getTitle () const noexcept
| Returns the title text for this component.
void | setTitle (const String &newTitle)
| Sets the title for this component.
String | getDescription () const noexcept
| Returns the description for this component.
void | setDescription (const String &newDescription)
| Sets the description for this component.
String | getHelpText () const noexcept
| Returns the help text for this component.
void | setHelpText (const String &newHelpText)
| Sets the help text for this component.
void | setAccessible (bool shouldBeAccessible)
| Sets whether this component and its children are visible to accessibility clients.
bool | isAccessible () const noexcept
| Returns true if this component and its children are visible to accessibility clients.
AccessibilityHandler * | getAccessibilityHandler ()
| Returns the accessibility handler for this component, or nullptr if this component is not accessible.
void | invalidateAccessibilityHandler ()
| Invalidates the AccessibilityHandler that is currently being used for this component.
Public Member Functions inherited from MouseListener
virtual | ~MouseListener ()=default
| Destructor.
Public Member Functions inherited from DragAndDropContainer
| DragAndDropContainer ()
| Creates a DragAndDropContainer.
virtual | ~DragAndDropContainer ()
| Destructor.
void | startDragging (const var &sourceDescription, Component *sourceComponent, const ScaledImage &dragImage=ScaledImage(), bool allowDraggingToOtherJuceWindows=false, const Point< int > *imageOffsetFromMouse=nullptr, const MouseInputSource *inputSourceCausingDrag=nullptr)
| Begins a drag-and-drop operation.
void | startDragging (const var &sourceDescription, Component *sourceComponent, Image dragImage, bool allowDraggingToOtherJuceWindows=false, const Point< int > *imageOffsetFromMouse=nullptr, const MouseInputSource *inputSourceCausingDrag=nullptr)
bool | isDragAndDropActive () const
| Returns true if something is currently being dragged.
int | getNumCurrentDrags () const
| Returns the number of things currently being dragged.
var | getCurrentDragDescription () const
| Returns the description of the thing that's currently being dragged.
var | getDragDescriptionForIndex (int index) const
| Same as the getCurrentDragDescription() method but takes a touch index parameter.
void | setCurrentDragImage (const ScaledImage &newImage)
| If a drag is in progress, this allows the image being shown to be dynamically updated.
void | setCurrentDragImage (const Image &newImage)
void | setDragImageForIndex (int index, const ScaledImage &newImage)
| Same as the setCurrentDragImage() method but takes a touch index parameter.
void | setDragImageForIndex (int index, const Image &newImage)
Public Member Functions inherited from DragAndDropTarget
virtual | ~DragAndDropTarget ()=default
| Destructor.
virtual void | itemDragEnter (const SourceDetails &dragSourceDetails)
| Callback to indicate that something is being dragged over this component.
virtual bool | shouldDrawDragImageWhenOver ()
| Overriding this allows the target to tell the drag container whether to draw the drag image while the cursor is over it.

## Static Public Member Functions
static ToolbarItemComponent * | createItem (ToolbarItemFactory &, int itemId)
Static Public Member Functions inherited from Component
static float JUCE_CALLTYPE | getApproximateScaleFactorForComponent (const Component *targetComponent)
| Returns the approximate scale factor for a given component by traversing its parent hierarchy and applying each transform and finally scaling this by the global scale factor.
static Component *JUCE_CALLTYPE | getCurrentlyFocusedComponent () noexcept
| Returns the component that currently has the keyboard focus.
static void JUCE_CALLTYPE | unfocusAllComponents ()
| If any component has keyboard focus, this will defocus it.
static void JUCE_CALLTYPE | beginDragAutoRepeat (int millisecondsBetweenCallbacks)
| Ensures that a non-stop stream of mouse-drag events will be sent during the current mouse-drag operation.
static bool JUCE_CALLTYPE | isMouseButtonDownAnywhere () noexcept
| Returns true if a mouse button is currently down.
static int JUCE_CALLTYPE | getNumCurrentlyModalComponents () noexcept
| Returns the number of components that are currently in a modal state.
static Component *JUCE_CALLTYPE | getCurrentlyModalComponent (int index=0) noexcept
| Returns one of the components that are currently modal.
Static Public Member Functions inherited from DragAndDropContainer
static DragAndDropContainer * | findParentDragContainerFor (Component *childComponent)
| Utility to find the DragAndDropContainer for a given Component.
static bool | performExternalDragDropOfFiles (const StringArray &files, bool canMoveFiles, Component *sourceComponent=nullptr, std::function< void()> callback=nullptr)
| This performs an asynchronous drag-and-drop of a set of files to some external application.
static bool | performExternalDragDropOfText (const String &text, Component *sourceComponent=nullptr, std::function< void()> callback=nullptr)
| This performs an asynchronous drag-and-drop of a block of text to some external application.

## Static Public Attributes
static const char *const | toolbarDragDescriptor

## Additional Inherited Members
Protected Member Functions inherited from DragAndDropContainer
virtual bool | shouldDropFilesWhenDraggedExternally (const DragAndDropTarget::SourceDetails &sourceDetails, StringArray &files, bool &canMoveFiles)
| Override this if you want to be able to perform an external drag of a set of files when the user drags outside of this container component.
virtual bool | shouldDropTextWhenDraggedExternally (const DragAndDropTarget::SourceDetails &sourceDetails, String &text)
| Override this if you want to be able to perform an external drag of text when the user drags outside of this container component.
virtual void | dragOperationStarted (const DragAndDropTarget::SourceDetails &)
| Subclasses can override this to be told when a drag starts.
virtual void | dragOperationEnded (const DragAndDropTarget::SourceDetails &)
| Subclasses can override this to be told when a drag finishes.

## Detailed Description

A toolbar component.

A toolbar contains a horizontal or vertical strip of ToolbarItemComponents, and looks after their order and layout.

Items (icon buttons or other custom components) are added to a toolbar using a ToolbarItemFactory - each type of item is given a unique ID number, and a toolbar might contain more than one instance of a particular item type.

Toolbars can be interactively customised, allowing the user to drag the items around, and to drag items onto or off the toolbar, using the ToolbarItemPalette component as a source of new items.

See also
  ToolbarItemFactory, ToolbarItemComponent, ToolbarItemPalette

## Member Enumeration Documentation

## ◆ ToolbarItemStyle

enum Toolbar::ToolbarItemStyle

Options for the way items should be displayed.

See also
  setStyle, getStyle

Enumerator
iconsOnly | Means that the toolbar should just contain icons.
iconsWithText | Means that the toolbar should have text labels under each icon.
textOnly | Means that the toolbar only display text labels for each item.

## ◆ CustomisationFlags

enum Toolbar::CustomisationFlags

Flags used by the showCustomisationDialog() method.

Enumerator
allowIconsOnlyChoice | If this flag is specified, the customisation dialog can show the "icons only" option on its choice of toolbar styles.
allowIconsWithTextChoice | If this flag is specified, the customisation dialog can show the "icons with text" option on its choice of toolbar styles.
allowTextOnlyChoice | If this flag is specified, the customisation dialog can show the "text only" option on its choice of toolbar styles.
showResetToDefaultsButton | If this flag is specified, the customisation dialog can show a button to reset the toolbar to its default set of items.
allCustomisationOptionsEnabled |

## ◆ ColourIds

enum Toolbar::ColourIds

A set of colour IDs to use to change the colour of various aspects of the toolbar.

These constants can be used either via the Component::setColour(), or LookAndFeel::setColour() methods.

See also
  Component::setColour, Component::findColour, LookAndFeel::setColour, LookAndFeel::findColour

Enumerator
backgroundColourId | A colour to use to fill the toolbar's background. For more control over this, override LookAndFeel::paintToolbarBackground().
separatorColourId | A colour to use to draw the separator lines.
buttonMouseOverBackgroundColourId | A colour used to paint the background of buttons when the mouse is over them.
buttonMouseDownBackgroundColourId | A colour used to paint the background of buttons when the mouse is held down on them.
labelTextColourId | A colour to use for drawing the text under buttons when the style is set to iconsWithText or textOnly.
editingModeOutlineColourId | A colour to use for an outline around buttons when the customisation dialog is active and the mouse moves over them.
customisationDialogBackgroundColourId | A colour used to paint the background of the CustomisationDialog.

## Constructor & Destructor Documentation

## ◆ Toolbar()

Toolbar::Toolbar | ( |  | ) |

Creates an empty toolbar component.

To add some icons or other components to your toolbar, you'll need to create a ToolbarItemFactory class that can create a suitable set of ToolbarItemComponents.

See also
  ToolbarItemFactory, ToolbarItemComponents

## ◆ ~Toolbar()

Toolbar::~Toolbar | ( |  | ) |
| override

Destructor.

Any items on the bar will be deleted when the toolbar is deleted.

## Member Function Documentation

## ◆ setVertical()

void Toolbar::setVertical | ( | bool | shouldBeVertical | ) |

Changes the bar's orientation.

See also
  isVertical

## ◆ isVertical()

bool Toolbar::isVertical | ( |  | ) | const
| noexcept

Returns true if the bar is set to be vertical, or false if it's horizontal.

You can change the bar's orientation with setVertical().

## ◆ getThickness()

int Toolbar::getThickness | ( |  | ) | const
| noexcept

Returns the depth of the bar.

If the bar is horizontal, this will return its height; if it's vertical, it will return its width.

See also
  getLength

## ◆ getLength()

int Toolbar::getLength | ( |  | ) | const
| noexcept

Returns the length of the bar.

If the bar is horizontal, this will return its width; if it's vertical, it will return its height.

See also
  getThickness

## ◆ clear()

void Toolbar::clear | ( |  | ) |

Deletes all items from the bar.

## ◆ addItem()

void Toolbar::addItem | ( | ToolbarItemFactory & | factory,
|  | int | itemId,
|  | int | insertIndex = -1 )

Adds an item to the toolbar.

The factory's ToolbarItemFactory::createItem() will be called by this method to create the component that will actually be added to the bar.

The new item will be inserted at the specified index (if the index is -1, it will be added to the right-hand or bottom end of the bar).

Once added, the component will be automatically deleted by this object when it is no longer needed.

See also
  ToolbarItemFactory

## ◆ removeToolbarItem()

void Toolbar::removeToolbarItem | ( | int | itemIndex | ) |

Deletes one of the items from the bar.

## ◆ removeAndReturnItem()

ToolbarItemComponent * Toolbar::removeAndReturnItem | ( | int | itemIndex | ) |

Removes an item from the bar and returns it.

## ◆ getNumItems()

int Toolbar::getNumItems | ( |  | ) | const
| noexcept

Returns the number of items currently on the toolbar.

See also
  getItemId, getItemComponent

## ◆ getItemId()

int Toolbar::getItemId | ( | int | itemIndex | ) | const
| noexcept

Returns the ID of the item with the given index.

If the index is less than zero or greater than the number of items, this will return nullptr.

See also
  getNumItems

## ◆ getItemComponent()

ToolbarItemComponent * Toolbar::getItemComponent | ( | int | itemIndex | ) | const
| noexcept

Returns the component being used for the item with the given index.

If the index is less than zero or greater than the number of items, this will return nullptr.

See also
  getNumItems

## ◆ addDefaultItems()

void Toolbar::addDefaultItems | ( | ToolbarItemFactory & | factoryToUse | ) |

Clears this toolbar and adds to it the default set of items that the specified factory creates.

See also
  ToolbarItemFactory::getDefaultItemSet

## ◆ getStyle()

ToolbarItemStyle Toolbar::getStyle | ( |  | ) | const
| noexcept

Returns the toolbar's current style.

See also
  ToolbarItemStyle, setStyle

## ◆ setStyle()

void Toolbar::setStyle | ( | const ToolbarItemStyle & | newStyle | ) |

Changes the toolbar's current style.

See also
  ToolbarItemStyle, getStyle, ToolbarItemComponent::setStyle

## ◆ showCustomisationDialog()

void Toolbar::showCustomisationDialog | ( | ToolbarItemFactory & | factory,
|  | int | optionFlags = allCustomisationOptionsEnabled )

Pops up a modal dialog box that allows this toolbar to be customised by the user.

The dialog contains a ToolbarItemPalette and various controls for editing other aspects of the toolbar. The dialog box will be opened modally, but the method will return immediately.

The factory is used to determine the set of items that will be shown on the palette.

The optionFlags parameter is a bitwise-or of values from the CustomisationFlags enum.

See also
  ToolbarItemPalette

## ◆ setEditingActive()

void Toolbar::setEditingActive | ( | bool | editingEnabled | ) |

Turns on or off the toolbar's editing mode, in which its items can be rearranged by the user.

(In most cases it's easier just to use showCustomisationDialog() instead of trying to enable editing directly).

See also
  ToolbarItemPalette

## ◆ toString()

String Toolbar::toString | ( |  | ) | const

Returns a string that represents the toolbar's current set of items.

This lets you later restore the same item layout using restoreFromString().

See also
  restoreFromString

## ◆ restoreFromString()

bool Toolbar::restoreFromString | ( | ToolbarItemFactory & | factoryToUse,
|  | const String & | savedVersion )

Restores a set of items that was previously stored in a string by the toString() method.

The factory object is used to create any item components that are needed.

See also
  toString

## ◆ paint()

void Toolbar::paint | ( | Graphics & | g | ) |
| overridevirtual

Components can override this method to draw their content.

The paint() method gets called when a region of a component needs redrawing, either because the component's repaint() method has been called, or because something has happened on the screen that means a section of a window needs to be redrawn.

Any child components will draw themselves over whatever this method draws. If you need to paint over the top of your child components, you can also implement the paintOverChildren() method to do this.

If you want to cause a component to redraw itself, this is done asynchronously - calling the repaint() method marks a region of the component as "dirty", and the paint() method will automatically be called sometime later, by the message thread, to paint any bits that need refreshing. In JUCE (and almost all modern UI frameworks), you never redraw something synchronously.

You should never need to call this method directly - to take a snapshot of the component you could use createComponentSnapshot() or paintEntireComponent().

Parameters

  g | the graphics context that must be used to do the drawing operations.

See also
  repaint, paintOverChildren, Graphics

Reimplemented from Component.

## ◆ resized()

void Toolbar::resized | ( |  | ) |
| overridevirtual

Called when this component's size has been changed.

A component can implement this method to do things such as laying out its child components when its width or height changes.

The method is called synchronously as a result of the setBounds or setSize methods, so repeatedly changing a components size will repeatedly call its resized method (unlike things like repainting, where multiple calls to repaint are coalesced together).

If the component is a top-level window on the desktop, its size could also be changed by operating-system factors beyond the application's control.

See also
  moved, setSize

Reimplemented from Component.

## ◆ mouseDown()

void Toolbar::mouseDown | ( | const MouseEvent & | event | ) |
| overridevirtual

Called when a mouse button is pressed.

The MouseEvent object passed in contains lots of methods for finding out which button was pressed, as well as which modifier keys (e.g. shift, ctrl) were held down at the time.

Once a button is held down, the mouseDrag method will be called when the mouse moves, until the button is released.

Parameters

  event | details about the position and status of the mouse event, including the source component in which it occurred

See also
  mouseUp, mouseDrag, mouseDoubleClick, contains

Reimplemented from Component.

## ◆ isInterestedInDragSource()

bool Toolbar::isInterestedInDragSource | ( | const SourceDetails & | dragSourceDetails | ) |
| overridevirtual

Callback to check whether this target is interested in the type of object being dragged.

Parameters

  dragSourceDetails | contains information about the source of the drag operation.

Returns
  true if this component wants to receive the other callbacks regarding this type of object; if it returns false, no other callbacks will be made.

Implements DragAndDropTarget.

## ◆ itemDragMove()

void Toolbar::itemDragMove | ( | const SourceDetails & | dragSourceDetails | ) |
| overridevirtual

Callback to indicate that the user is dragging something over this component.

This gets called when the user moves the mouse over this component while dragging something. Normally overriding itemDragEnter() and itemDragExit() are enough, but this lets you know what happens in-between.

Parameters

  dragSourceDetails | contains information about the source of the drag operation.

Reimplemented from DragAndDropTarget.

## ◆ itemDragExit()

void Toolbar::itemDragExit | ( | const SourceDetails & | dragSourceDetails | ) |
| overridevirtual

Callback to indicate that something has been dragged off the edge of this component.

This gets called when the user moves the mouse out of this component while dragging something.

If you've used itemDragEnter() to repaint your component and give feedback, use this as a signal to repaint it in its normal state.

Parameters

  dragSourceDetails | contains information about the source of the drag operation.

See also
  itemDragEnter

Reimplemented from DragAndDropTarget.

## ◆ itemDropped()

void Toolbar::itemDropped | ( | const SourceDetails & | dragSourceDetails | ) |
| overridevirtual

Callback to indicate that the user has dropped something onto this component.

When the user drops an item this get called, and you can use the description to work out whether your object wants to deal with it or not.

Note that after this is called, the itemDragExit method may not be called, so you should clean up in here if there's anything you need to do when the drag finishes.

Parameters

  dragSourceDetails | contains information about the source of the drag operation.

Implements DragAndDropTarget.

## ◆ lookAndFeelChanged()

void Toolbar::lookAndFeelChanged | ( |  | ) |
| overridevirtual

Called to let the component react to a change in the look-and-feel setting.

When the look-and-feel is changed for a component, this method, repaint(), and colourChanged() are called on the original component and all its children recursively.

It can also be triggered manually by the sendLookAndFeelChange() method, in case an application uses a LookAndFeel class that might have changed internally.

See also
  sendLookAndFeelChange, getLookAndFeel

Reimplemented from Component.

## ◆ updateAllItemPositions()

void Toolbar::updateAllItemPositions | ( | bool | animate | ) |

## ◆ createItem()

static ToolbarItemComponent * Toolbar::createItem | ( | ToolbarItemFactory & | ,
|  | int | itemId )
| static

## ◆ createAccessibilityHandler()

std::unique_ptr< AccessibilityHandler > Toolbar::createAccessibilityHandler | ( |  | ) |
| overridevirtual

Override this method to return a custom AccessibilityHandler for this component.

The default implementation creates and returns a AccessibilityHandler object with an unspecified role, meaning that it will be visible to accessibility clients but without a specific role, action callbacks or interfaces. To control how accessibility clients see and interact with your component subclass AccessibilityHandler, implement the desired behaviours, and return an instance of it from this method in your component subclass.

The accessibility handler you return here is guaranteed to be destroyed before its Component, so it's safe to store and use a reference back to the Component inside the AccessibilityHandler if necessary.

This function should rarely be called directly. If you need to query a component's accessibility handler, it's normally better to call getAccessibilityHandler(). The exception to this rule is derived implementations of createAccessibilityHandler(), which may find it useful to call the base class implementation, and then wrap or modify the result.

See also
  getAccessibilityHandler

Reimplemented from Component.

## Member Data Documentation

## ◆ toolbarDragDescriptor

const char* const Toolbar::toolbarDragDescriptor
| static

The documentation for this class was generated from the following file:

- juce_Toolbar.h